#!/bin/bash
#

# install festival
# install this nice voice:
#sudo apt-get install festlex-cmu
#cd /usr/share/festival/voices/english/
#sudo wget -c http://www.speech.cs.cmu.edu/cmu_arctic/packed/cmu_us_clb_arctic-0.95-release.tar.bz2
#sudo tar jxf cmu_us_clb_arctic-0.95-release.tar.bz2 
#sudo ln -s cmu_us_clb_arctic cmu_us_clb_arctic_clunits
#sudo cp /etc/festival.scm /etc/festival.scm.backup
#sudo echo "(set! voice_default 'voice_cmu_us_clb_arctic_clunits)" >> /etc/festival.scm
#echo "This is a test." | festival --tts
#rm /usr/share/festival/voices/english/cmu_us_clb_arctic-0.95-release.tar.bz2
# need this for CMU files apt install festlex-cmu
#info from http://ubuntuforums.org/showthread.php?t=677277
# more info http://ubuntuforums.org/showthread.php?t=751169

# Variables

# Available Voices Installed
# cmu_us_slt_arctic_clunits
# us2_mbrola
# en1_mbrola
# us1_mbrola
# cmu_us_bdl_arctic_clunits
# cmu_us_jmk_arctic_clunits
# rab_diphone
# us3_mbrola
# cmu_us_awb_arctic_clunits
# ked_diphone
# kal_diphone
# cmu_us_clb_arctic_clunits
# cmu_us_ksp_arctic_clunits
# cmu_us_rms_arctic_clunits

VOICE="cmu_us_clb_arctic_clunits"

# string used to set voice -eval (voice_XXXXXXXX)
# string used to set volume -scale (1-100)
VOICEVOLUME="4"

VOICESTRING="-eval (voice_$VOICE) -scale $VOICEVOLUME"

INPUTFILE="phrases.txt"
NEWFOLDER=`date +%F-%H:%M`-$VOICE

#output some info
echo "Creating voices from " $INPUTFILE ", and saving it into a new folder ./" $NEWFOLDER ". Voice list copied to " $NEWFOLDER"/VoiceList.txt"
mkdir $NEWFOLDER
# Put a copy of the phrase file into folder
cp $INPUTFILE $NEWFOLDER/VoiceList.txt
 
# Do some work!
while IFS=$'   ' read -r -a myArray
do
   if [[ ${myArray[0]} && ${myArray[1]} ]]; then
      echo "Creating file - " $NEWFOLDER"/"${myArray[0]}".wav With Text: " ${myArray[@]:1}
      echo ${myArray[@]:1} | text2wave $VOICESTRING >$NEWFOLDER"/"${myArray[0]}.wav
	#echo ${myArray[1]}
	#echo ${myArray[@]:1}
   else
      echo "Missing Data for line: " ${myArray[0]}
   fi
done < $INPUTFILE


